Subject: Re: [bug#48325] julia-1.6 guix

From: zimoun <[email-masked]>
Date: Tue, 11 May 2021 11:55:26 +0200

Hi,

On Tue, 11 May 2021 at 11:18, Nicolò Balzarotti <[email-masked]> wrote:
> zimoun <[email-masked]> writes:

>> Please, split this patch.  One per update, i.e., 5 patches I guess.
>
> Some changes should probably be committed together since current julia
> will fail to build with newer deps versions, but at least for utf8proc
> I'm sure this can be splitted.

The issue is that the update of pcre2 is a ’core-updates’ change, IIUC:

  guix refresh -l pcre2

so the package cannot be simply updated.  This one also should be
splitted, IMHO.

Is the current [email-masked] ’will fail’ for sure or probably ’would fail’
with [email-masked] and [email-masked]?  I have not tried
yet. :-)

>>> +         (add-before 'install 'symlink-libraries
>>
>> [...]
>>
>>> +               (link "zlib" "usr/lib/julia/" "libz\\.so")
>>
>> Does this fix
>>
>>    <http://issues.guix.gnu.org/48238>
>>
>> ?
>> Does it make sense?
>>
> I just tried running
>> cd /gnu/store/fp5by15552ihyppxppigmbxs981rd08h-julia-1.6.1
>> find -type f -exec grep '/tmp/guix-build-julia-1.5.3.drv-0' {} \;
>
> and it returns nothing.  Also, your Pkg.add("GZip"); using GZip worked

Cool!

> (but it printed
>
> ┌ Error: curl_easy_setopt: 48
> └ @ Downloads.Curl
> ~/guix-build-julia-1.6.1.drv-0/julia-1.6.1/usr/share/julia/stdlib/v1.6/Downloads/src/Curl/utils.jl:36
>
> which might be worth investigating)

Thanks for trying and reporting.  Did you use a --pure or --container
environment?

>>> +       ("nss-certs" ,nss-certs)         ; required to precompile
>>
>> Hum?  Is it really necessary?
>>
> I think that the alternative is to disable a few tests.  I opened a bug
> report a few months ago here:
> https://github.com/JuliaLang/julia/issues/40185
>
>>> +       ("glibc-locales" ,glibc-locales)
>>
>> Idem.  Is it really necessary?  Because it is a “big“ packages which
>> drastically increases the closure size of the Julia package.
>>
>
> I think it's the same as before (fixes a few tests) but I cannot verify
> this, Jean-Baptiste do you know what breaks when this is removed?

Well, ‘guix size glibc-locales’ reports ~922MiB.  Although this package
is probably already on the store, I would prefer to avoid to add it as
an input.  Currently, ’guix size julia’ says ~1080MiB.  How much with
the glibc-locales as inputs?

Thanks for the patch and the explanations.

Cheers,
simon